# SourcePath: gcc-gplv3-4.5.1/20131216
Summary: GCC libraries and headers for glibc
Name: sony-target-dev-gcc-gplv3-libs
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-gcc-libs
Version: 4.5.1
Release: 08000401
License: special exception
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
URL: http://www.gnu.org/software/gcc
Source0: gcc-%{version}.tar.bz2

Patch1: gcc-4.5.1-texi.patch
Patch101: elfutils-TEXTREL-fix.patch
Patch102: gcc-4.5.1-pr40974.patch
Patch103: gcc-4.5.1-Ignore_artificial_typedefs.patch
Patch104: gcc-4.5.1-libmudflap-pass41-frag-fix.patch
Patch105: gcc-4.5.1-libmudflap-regression-fix.patch
Patch106: gcc-4.5.1-arm-ARMCC-build-break-fix-for-cpp.patch
Patch107: gcc-4.5.1-pr43655.patch
Patch108: gcc-4.5.1-pr44392.patch
Patch109: gcc-4.5.1-pr44469.patch
Patch110: gcc-4.5.1-pr44545.patch
Patch111: gcc-4.5.1-pr45052.patch
Patch112: gcc-4.5.1-pr45112.patch
Patch113: gcc-4.5.1-pr45200.patch
Patch114: gcc-4.5.1-pr45241.patch
Patch115: gcc-4.5.1-pr45726.patch
Patch116: gcc-4.5.1-pr46058.patch
Patch117: gcc-4.5.1-pr46099.patch
Patch118: gcc-4.5.1-pr46123.patch
Patch119: gcc-4.5.1-pr46160.patch
Patch120: gcc-4.5.1-pr46177.patch
Patch121: gcc-4.5.1-pr46498.patch
Patch122: gcc-4.5.1-pr46547.patch
Patch123: gcc-4.5.1-pr46806.patch
Patch124: gcc-4.5.1-pr46893.patch
Patch125: gcc-4.5.1-pr47365.patch
Patch126: gcc-4.5.1-Add-a-new-argument-to-SELECT_CC_MODE.patch
Patch201: gcc-4.5.1-enable-sibling-calls-for-thumb-2.patch
Patch202: gcc-4.5.1-New-costing-infrastructure-on-ARM.patch
Patch203: gcc-4.5.1-Cleanup-ARM-mcpu-march-handling.patch
Patch204: gcc-4.5.1-Fix-SUBTARGET_CPU_DEFAULT.patch

# fstrict-volatile-bitfields option support patches
Patch205: gcc-4.5.1-linaro-add-new-opt-fstrict-volatile-bitfields.patch
Patch206: gcc-4.5.1-linaro-make-default-to-fstrict-volatile-bitfields-for-arm.patch
Patch207: gcc-4.5.1-linaro-fix-fstrict-volatile-bitfields.patch
Patch208: gcc-4.6-pr43572-export-call_may_clobber_ref_p.patch
Patch209: gcc-4.6-pr43879-tailcall-fix.patch

# Patch to build Sony CE Linux distro.
Patch401: gcc-4.5.1-arm-sony-multidialect-support.patch
Patch402: gcc-4.5.1-gcc_cp_cfns_h.patch
Patch403: gcc-4.5.1-build-fix.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Prefix: %{sony_target_dir}

%description
This is the GNU C compiler, a fairly portable optimizing compiler which
supports multiple languages.  This package includes support for C.  It also
includes the GNU C preprocessor.

%package -n %{pkgname}
Summary: GCC libraries and headers for glibc
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
This is the GNU C compiler, a fairly portable optimizing compiler which
supports multiple languages.  This package includes support for C.  It also
includes the GNU C preprocessor.

%prep
%setup -q -n gcc-%{version}
%patch1 -p1
%patch101 -p2
%patch102 -p1
%patch103 -p1
%patch104 -p0
%patch105 -p1
%patch106 -p1
%patch107 -p2
%patch108 -p2
%patch109 -p3
%patch110 -p1
%patch111 -p2
%patch112 -p2
%patch113 -p2
%patch114 -p2
%patch115 -p1
%patch116 -p2
%patch117 -p2
%patch118 -p2
%patch119 -p2
%patch120 -p2
%patch121 -p2
%patch122 -p2
%patch123 -p2
%patch124 -p2
%patch125 -p2
%patch126 -p0
%patch201 -p0
%patch202 -p1
%patch203 -p0
%patch204 -p1

%patch205 -p0
%patch206 -p0
%patch207 -p0
%patch208 -p1
%patch209 -p1

%patch401 -p1
%patch402 -p1
%patch403 -p1

%build
%if %{sony_host_arch} == "x86_64"
export LDFLAGS="-L%{sony_host_lib64_dir}"
%endif

%sony_cross_dev_setup

( cd gcc && autoconf ) &&
( cd libstdc++-v3 && autoconf && aclocal ) &&
( cd libmudflap && autoconf && aclocal ) &&
( cd libssp && autoconf && aclocal ) &&
( cd libgomp && autoconf && aclocal ) &&
( cd gcc && autoheader ) &&
####################################################
#  libgcc, libstdc++-v3, libmudflap, libssp, libgomp
####################################################
%sony_cross_dev_configure \
	--prefix=%{sony_target_dev_prefix} \
	--enable-languages=c,c++ \
%if "%{sony_target_cpu_id}" != "%%%{sony_target_cpu_id}"
%if "%{sony_target_cpu}" != "arm"
	--with-cpu=%{sony_target_cpu_id} \
%endif
%endif
%if "%{sony_target_arch_id}" != "%%%{sony_target_arch_id}"
	--with-arch=%{sony_target_arch_id} \
%endif
%if "%{sony_target_tune_id}" != "%%%{sony_target_tune_id}"
	--with-tune=%{sony_target_tune_id} \
%endif
%if "%{sony_target_fpu}" == "no"
	--with-float=soft \
%endif
%if "%{sony_target_altivec}" == "yes"
	--enable-altivec \
%endif
	--with-sysroot=/usr/local/%{sony_tool_triplet}/target \
	--with-gmp=%{sony_host_dir} \
	--with-mpfr=%{sony_host_dir} \
	--with-mpc=%{sony_host_dir} \
	--enable-__cxa_atexit \
	--disable-multilib \
	--enable-threads=posix \
	--enable-shared \
	--with-gxx-include-dir=%{sony_target_dev_include_dir}/c++/%{version} &&
	#
	#  Build all lib.
	#
make "FLAGS_FOR_TARGET= -O2 %{sony_target_machine_option}" "CFLAGS_FOR_TARGET= -O2 %{sony_target_machine_option}" "CXXFLAGS_FOR_TARGET= -O2 %{sony_target_machine_option}" all-target-libgcc \
      all-target-libstdc++-v3 \
      all-target-libmudflap \
      all-target-libssp \
      all-target-libgomp

%install
%sony_cross_dev_setup

rm -rf %{buildroot}

cd %{sony_objdir} && make \
   DESTDIR=%{buildroot}%{sony_target_dir} install

rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_prefix}/share
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_prefix}/libexec
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}

%define toollibdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
%define libdir %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

mv %{libdir}/../%{sony_target_config}/lib/* %{libdir}
# remove libiberty.a which will conflict with binutils.
%if %{sony_host_arch} == "x86_64"
rm -rf %{buildroot}%{sony_target_dir}/%{sony_target_dev_prefix}/lib64
%endif

rm -rf %{libdir}/libiberty.a
rm -rf %{libdir}/../%{sony_target_config}

# remove libstdc++.so.6.0.14-gdb.py due to license issue
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libstdc++.so.6.0.14-gdb.py

for l in `ls %{libdir}/*.la`; do
  echo "$(cat $l | sed -e 's,%{sony_target_config}/,,')" > $l
done

mkdir -p %{libdir}
mkdir -p %{toollibdir}

mv %{libdir}/*.a %{toollibdir}
mv %{libdir}/gcc %{toollibdir}

# link crt*.o, *.a, include and include-fixed to /usr/lib dir on target.
for l in `ls -d %{toollibdir}/gcc/%{sony_target_config}/%{version}/{*.a,crt*o,include,include-fixed}`; do
  ln -s gcc/%{sony_target_config}/%{version}/$(basename $l) \
        %{libdir}/$(basename $l)
done

%demangle_libtool


# for CE 6.x

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
        ln -s ../..%{sony_target_devtool_lib_dir}/$l \
                %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
done

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root)
%{sony_target_dir}%{sony_target_dev_include_dir}/*
%{sony_target_dir}%{sony_target_dev_lib_dir}/*
%{sony_target_dir}%{sony_target_devtool_lib_dir}/*

%changelog
* Thu Jan 28 2021 Sony Corporation
- Initial build for CE Linux 8.0.4.X

* Fri Jan 25 2019 Sony Corporation
- Initial build for 8.0.3.0.

* Wed Nov 30 2016 Sony Corporation
- Initial build for 8.0.2.0.

* Fri Dec 27 2013 Sony Corporation
- Added pr43879 fix and supporting change-set for memcpy tail call issue.

* Thu Sep 20 2013 Sony Corporation
- Added fstrict-volatile-bitfields option support patches.

* Thu Apr 21 2011 Sony Corporation
- Fix override of SUBTARGET_CPU_DEFAULT.

* Fri Mar 11 2011 Sony Corporation
- GCC-4.5.1 information table patch merging.
- glibc softfp invalid exception fix patch is added.

* Thu Mar 10 2011 Sony Corporation
- ARMCC patch refresh for gcc-4.5.1

* Tue Mar 08 2011 Sony Corporation
- libmudflap pass41-frag fix patch is added.
- libmudflap regression fix patch is added.

* Fri Jan 21 2011 Sony Corporation
- Cleanup ARM -mcpu -march handling patch is added.
- New costing infrastructure on ARM patch is added for dependency.

* Wed Jan 19 2011 Sony Corporation
- a patch to enable sibling calls for Thumb2 is added.

* Wed Jan 12 2011 Sony Corporation
- added Ignore_artificial_typedefs fix patch

* Wed Aug 25 2010 Sony Corporation
- Initial build.
